/***
StackPivotChecker: A BTF based StackPivoting Exploit Detection System
!!! This code is for education purpose and just demo code on Windows 7 32bit OS!!!
Copyright (c) 2012-2016, Intel Corporation
 
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; Version 2.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
Contact information:
xiaoning.li@intel.com
*/ 

#include "stackpivotchecker.h"




#define MESSAGE_MAXLENTH  0x200

HINSTANCE g_hInst;  

HANDLE BTF_hDevice = NULL;

int Initialized = 0;

T_BTF_DEVICE_MESSAGE Msg = {0};

//use sys call hook to force TF every time
#define CODELEN 0x20
static unsigned char SyscallCodes[CODELEN]={0};
// only works for windows 7 32bits
static int SyscallAddress = 0x7ffe0300;
static int SyscallEnterAddress = 0;

int Exit_Enable = 0;

//sysenter hook
__declspec(naked) void SysEnter()
{

	__asm{

	cmp [esp],0
    JZ SYSEXIT
	add esp,4
	push eax
	pushfd
	pop eax
	and eax,0xfffffeff
	push eax
	popfd
	pop eax


	mov edx, esp
	__emit 0x0f
	__emit 0x34
	

SYSEXIT:
	add esp,4
	cmp [Exit_Enable],0
	jz WithoutTF
	
	push eax
	pushfd
	pop eax
	or eax,0x100
	push eax
	popfd
	pop eax
	ret

WithoutTF:
	ret
	}
}


//hook syscall code
T_BTF_STATUS Hook_Syscall(void)
{

	DWORD dwOldProtect;
	
    SyscallEnterAddress = *((int*)SyscallAddress);

	//to do: this RWX memory should be recovered back to RX 
	if (!VirtualProtect ((PCHAR)SyscallEnterAddress,
						 4,
						 PAGE_EXECUTE_READWRITE,
						 &dwOldProtect
						 ))
	{
		return BTF_STATUS_ERROR;
	} 

	memcpy(SyscallCodes,(unsigned char *)SyscallEnterAddress,CODELEN);
	//fixed hook
	*((unsigned char *)SyscallEnterAddress+0)=0x6a;
	*((unsigned char *)SyscallEnterAddress+1)=0x01;
	*((unsigned char *)SyscallEnterAddress+2)=0xeb;
	*((unsigned char *)SyscallEnterAddress+3)=0x0c;
	*((unsigned char *)SyscallEnterAddress+4)=0x6a;
	*((unsigned char *)SyscallEnterAddress+5)=0x00;
	*((unsigned char *)SyscallEnterAddress+6)=0xeb;
	*((unsigned char *)SyscallEnterAddress+7)=0x08;

	int RelativeOffset = (UINT32)0x80000000-(UINT32)SyscallEnterAddress - 0x10 - 5 + (UINT32)(&SysEnter)+(UINT32)0x80000000;
	
	*((unsigned char *)SyscallEnterAddress+0x10)=0xe9;
	*((UINT32*)((unsigned char *)SyscallEnterAddress+0x11))=RelativeOffset;

	
	return BTF_STATUS_SUCCESS;

}

T_BTF_STATUS UnHook_Syscall(void)
{
	Exit_Enable = 0;

	DWORD dwOldProtect;
	SyscallEnterAddress = *((int*)SyscallAddress);

	//to do: this RWX memory should be recovered back to RX 
	if (!VirtualProtect ((PCHAR)SyscallEnterAddress,
						 4,
						 PAGE_EXECUTE_READWRITE,
						 &dwOldProtect
						 ))
	{
		return	BTF_STATUS_ERROR;
	} 

	memcpy((unsigned char *)SyscallEnterAddress,SyscallCodes,CODELEN);


	return	BTF_STATUS_SUCCESS;

}

// call ioctl with btf_driver
T_BTF_STATUS Call_Ioctl( HANDLE hDevice,UINT IoctlCode, T_BTF_DEVICE_MESSAGE* Msg)
{
	unsigned char OutputBuffer[MESSAGE_MAXLENTH] = {0};
	unsigned char InputBuffer[MESSAGE_MAXLENTH] = {0};

	BOOL bRc;
	ULONG bytesReturned;

	if(Msg==NULL)
		return BTF_STATUS_ERROR;

	memset(InputBuffer, 0, sizeof(InputBuffer));
	memset(OutputBuffer, 0, sizeof(OutputBuffer));
		
	memcpy(InputBuffer,&(Msg->Data),sizeof(Msg->Data));

	bRc = DeviceIoControl ( hDevice,
						   (DWORD) IoctlCode,
						   &InputBuffer,
						   sizeof(Msg->Data),
						   &OutputBuffer,
						   sizeof(Msg->Data),
						   &bytesReturned,
						   NULL
							   );
	
	   if ( !bRc )
	   {
		   return BTF_STATUS_ERROR;
	
	   }

	   return BTF_STATUS_SUCCESS;
}


T_BTF_STATUS BTF_OpenDevice(void)
{
        BTF_hDevice = CreateFileW( L"\\\\.\\btf_device",
                            GENERIC_READ | GENERIC_WRITE,
                            0,
                            NULL,
                            CREATE_ALWAYS,
                            FILE_ATTRIBUTE_NORMAL,
                            NULL);

        if ( BTF_hDevice == INVALID_HANDLE_VALUE ){
            return BTF_STATUS_ERROR;
        }

		Msg.Data = 0;
		Call_Ioctl(BTF_hDevice,IOCTL_BTF_BTFTRACE_OPEN,&Msg);

 
		
		Initialized = 1;



		return BTF_STATUS_SUCCESS;
}


T_BTF_STATUS BTF_CloseDevice(void)
{
	if(!Initialized)
		return BTF_STATUS_ERROR;
 

	Msg.Data = 0;
	Call_Ioctl(BTF_hDevice,IOCTL_BTF_BTFTRACE_CLOSE,&Msg);

    CloseHandle ( BTF_hDevice );
	BTF_hDevice = NULL;

	Initialized = 0;

	return BTF_STATUS_SUCCESS;
}

BOOL APIENTRY DllMain( HANDLE hModule,DWORD  dwreason, LPVOID lpReserved)
{
    UNREFERENCED_PARAMETER(lpReserved);

    g_hInst = (HINSTANCE)hModule;
    switch(dwreason) {
        case DLL_PROCESS_ATTACH:
			Hook_Syscall();
			BTF_OpenDevice();
			Exit_Enable = 1;
			
			break;
        case DLL_THREAD_ATTACH:
        case DLL_THREAD_DETACH:
			break;
        case DLL_PROCESS_DETACH:
			
			BTF_CloseDevice();
			UnHook_Syscall();
            break;
    }
    return TRUE;
}


